(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@energyweb/origin-ui-localization'), require('react-i18next'), require('yup'), require('@energyweb/origin-ui-core'), require('@energyweb/origin-ui-web3'), require('react-router'), require('react'), require('@energyweb/origin-backend-react-query-client'), require('@energyweb/origin-ui-utils'), require('@energyweb/origin-backend-core'), require('@energyweb/utils-general'), require('@mui/icons-material')) :
  typeof define === 'function' && define.amd ? define(['exports', '@energyweb/origin-ui-localization', 'react-i18next', 'yup', '@energyweb/origin-ui-core', '@energyweb/origin-ui-web3', 'react-router', 'react', '@energyweb/origin-backend-react-query-client', '@energyweb/origin-ui-utils', '@energyweb/origin-backend-core', '@energyweb/utils-general', '@mui/icons-material'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.UserLogic = {}, global.originUiLocalization, global.reactI18next, global.yup, global.originUiCore, global.originUiWeb3, global.reactRouter, global.React, global.originBackendReactQueryClient, global.originUiUtils, global.originBackendCore, global.utilsGeneral, global.MUIIconsMaterial));
})(this, (function (exports, originUiLocalization, reactI18next, Yup, originUiCore, originUiWeb3, reactRouter, React, originBackendReactQueryClient, originUiUtils, originBackendCore, utilsGeneral, iconsMaterial) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () { return e[k]; }
          });
        }
      });
    }
    n["default"] = e;
    return Object.freeze(n);
  }

  var Yup__namespace = /*#__PURE__*/_interopNamespace(Yup);
  var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

  var prepareLanguageOptions = function prepareLanguageOptions(t) {
    var supportedLanugages = Object.keys(originUiLocalization.SupportedLanguagesEnum);
    return supportedLanugages.map(function (language) {
      return {
        label: t("user.settings.languages.".concat(language)),
        value: language
      };
    });
  };

  var useSettingsPageLogic = function useSettingsPageLogic() {
    var t = reactI18next.useTranslation().t;
    return {
      notificationsLabel: t('user.settings.notifications'),
      languageLabel: t('user.settings.language'),
      languageOptions: prepareLanguageOptions(t),
      buttonText: t('general.buttons.update')
    };
  };

  var useOrganizationBlockchainAddressLogic = function useOrganizationBlockchainAddressLogic() {
    var t = reactI18next.useTranslation().t;
    return {
      title: t('user.profile.orgBlockchainAccountAddress'),
      popoverText: [t('user.profile.popover.blockchainWhatIs'), t('user.profile.popover.blockchainWhatFor'), t('user.profile.popover.blockchainHowTo')],
      buttonText: t('user.profile.connectBlockchain')
    };
  };

  var useExchangeDepositAddressLogic = function useExchangeDepositAddressLogic() {
    var t = reactI18next.useTranslation().t;
    return {
      title: t('user.profile.exchangeAddressTitle'),
      popoverText: [t('user.profile.popover.exchangeAddressWhatFor'), t('user.profile.popover.exchangeAddressHowTo')]
    };
  };

  var useUpdateUserAccountDataFormConfig = function useUpdateUserAccountDataFormConfig(user) {
    var _a, _b, _c, _d, _e;

    var t = reactI18next.useTranslation().t;
    var firstName = user.firstName,
        lastName = user.lastName,
        telephone = user.telephone,
        status = user.status,
        kycStatus = user.kycStatus,
        emailConfirmed = user.emailConfirmed;
    var initialFormData = {
      firstName: firstName,
      lastName: lastName,
      telephone: telephone,
      status: status,
      kycStatus: kycStatus,
      emailConfirmed: emailConfirmed ? t('user.profile.yes') : t('user.profile.no')
    };
    return {
      buttonText: t('general.buttons.edit'),
      fields: [{
        label: t('user.profile.firstName'),
        name: 'firstName',
        required: true,
        inputProps: (_a = {}, _a['data-cy'] = 'firstName', _a)
      }, {
        label: t('user.profile.lastName'),
        name: 'lastName',
        required: true,
        inputProps: (_b = {}, _b['data-cy'] = 'lastName', _b)
      }, {
        label: t('user.profile.telephone'),
        name: 'telephone',
        required: true,
        inputProps: (_c = {}, _c['data-cy'] = 'telephone', _c)
      }, {
        label: t('user.profile.status'),
        name: 'status',
        textFieldProps: {
          disabled: true
        },
        inputProps: (_d = {}, _d['data-cy'] = 'status', _d)
      }, {
        label: t('user.profile.kycStatus'),
        name: 'kycStatus',
        textFieldProps: {
          disabled: true
        }
      }, {
        label: t('user.profile.emailConfirmed'),
        name: 'emailConfirmed',
        textFieldProps: {
          disabled: true
        }
      }],
      buttonWrapperProps: {
        justifyContent: 'flex-start'
      },
      buttonProps: (_e = {}, _e['data-cy'] = 'user-data-change-button', _e),
      initialValues: initialFormData,
      twoColumns: true,
      inputsVariant: 'filled',
      validationSchema: Yup__namespace.object().shape({
        firstName: Yup__namespace.string().label(t('user.profile.firstName')).required(),
        lastName: Yup__namespace.string().label(t('user.profile.lastName')).required(),
        telephone: Yup__namespace.string().required().min(10).label(t('user.profile.telephone'))
      })
    };
  };

  var useUpdateUserAccountEmailFormConfig = function useUpdateUserAccountEmailFormConfig(initialValues) {
    var _a, _b;

    var t = reactI18next.useTranslation().t;
    return {
      buttonText: t('general.buttons.change'),
      fields: [{
        label: t('user.profile.email'),
        name: 'email',
        required: true,
        inputProps: (_a = {}, _a['data-cy'] = 'email', _a)
      }],
      buttonWrapperProps: {
        justifyContent: 'flex-start'
      },
      buttonProps: (_b = {}, _b['data-cy'] = 'email-change-button', _b),
      initialValues: {
        email: initialValues === null || initialValues === void 0 ? void 0 : initialValues.email
      },
      inputsVariant: 'filled',
      validationSchema: Yup__namespace.object().shape({
        email: Yup__namespace.string().email().label(t('user.profile.email')).required()
      })
    };
  };

  var INITIAL_FORM_VALUES$2 = {
    oldPassword: '',
    newPassword: '',
    newPasswordConfirm: ''
  };
  var useUpdateUserAccountPasswordFormConfig = function useUpdateUserAccountPasswordFormConfig() {
    var _a, _b, _c, _d;

    var t = reactI18next.useTranslation().t;
    return {
      buttonText: t('general.buttons.change'),
      fields: [{
        type: 'password',
        label: t('user.profile.currentPassword'),
        name: 'oldPassword',
        required: true,
        inputProps: (_a = {}, _a['data-cy'] = 'oldPassword', _a)
      }, {
        type: 'password',
        label: t('user.profile.newPassword'),
        name: 'newPassword',
        required: true,
        inputProps: (_b = {}, _b['data-cy'] = 'newPassword', _b)
      }, {
        type: 'password',
        label: t('user.profile.newPasswordConfirm'),
        name: 'newPasswordConfirm',
        required: true,
        inputProps: (_c = {}, _c['data-cy'] = 'newPasswordConfirm', _c)
      }],
      buttonWrapperProps: {
        justifyContent: 'flex-start'
      },
      buttonProps: (_d = {}, _d['data-cy'] = 'password-change-button', _d),
      initialValues: INITIAL_FORM_VALUES$2,
      inputsVariant: 'filled',
      validationSchema: Yup__namespace.object().shape({
        oldPassword: Yup__namespace.string().label(t('user.profile.currentPassword')).required(),
        newPassword: Yup__namespace.string().label(t('user.profile.newPassword')).required(),
        newPasswordConfirm: Yup__namespace.string().oneOf([Yup__namespace.ref('newPassword'), null], t('user.profile.confirmDoesntMatch')).label(t('user.profile.newPasswordConfirm')).required()
      })
    };
  };

  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */

  function __awaiter(thisArg, _arguments, P, generator) {
      function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
      return new (P || (P = Promise))(function (resolve, reject) {
          function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
          function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
          function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
          step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
  }

  function __generator(thisArg, body) {
      var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
      return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
      function verb(n) { return function (v) { return step([n, v]); }; }
      function step(op) {
          if (f) throw new TypeError("Generator is already executing.");
          while (_) try {
              if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
              if (y = 0, t) op = [op[0] & 2, t.value];
              switch (op[0]) {
                  case 0: case 1: t = op; break;
                  case 4: _.label++; return { value: op[1], done: false };
                  case 5: _.label++; y = op[1]; op = [0]; continue;
                  case 7: op = _.ops.pop(); _.trys.pop(); continue;
                  default:
                      if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                      if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                      if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                      if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                      if (t[2]) _.ops.pop();
                      _.trys.pop(); continue;
              }
              op = body.call(thisArg, _);
          } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
          if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
      }
  }

  var useConnectMetamaskPlaceholderLogic = function useConnectMetamaskPlaceholderLogic(allowedChainIds) {
    var t = reactI18next.useTranslation().t;
    var connect = originUiWeb3.useWeb3().connect;

    var handleInstall = function handleInstall() {
      window.location.replace('https://metamask.io/');
    };

    var handleError = function handleError(error) {
      if (error instanceof originUiWeb3.NotAllowedChainIdError) {
        originUiCore.showNotification(t('metamask.notifications.unsupportedNetwork'), originUiCore.NotificationTypeEnum.Error);
      } else {
        originUiCore.showNotification(t('metamask.notifications.unknownError'), originUiCore.NotificationTypeEnum.Error);
      }
    };

    var handleConnect = function handleConnect() {
      return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
          switch (_a.label) {
            case 0:
              return [4
              /*yield*/
              , connect(new originUiWeb3.MetamaskAdapter(allowedChainIds, handleError))];

            case 1:
              _a.sent();

              return [2
              /*return*/
              ];
          }
        });
      });
    };

    var noMetamaskInstalled = !(window.web3 || window.ethereum);
    var clickHandler = noMetamaskInstalled ? handleInstall : handleConnect;
    var buttonText = noMetamaskInstalled ? t('metamask.installMetamask') : t('metamask.connectMetamask');
    var title = t('metamask.blockRequireInstalledAndConnected');
    return {
      clickHandler: clickHandler,
      buttonText: buttonText,
      title: title
    };
  };

  var INITIAL_FORM_VALUES$1 = {
    username: '',
    password: ''
  };
  var useUserLogInFormConfig = function useUserLogInFormConfig(formSubmitHandler) {
    var _a, _b, _c;

    var t = reactI18next.useTranslation().t;
    return {
      buttonFullWidth: true,
      buttonText: t('user.login.loginButton'),
      fields: [{
        label: t('user.login.email'),
        name: 'username',
        required: true,
        inputProps: (_a = {}, _a['data-cy'] = 'email', _a)
      }, {
        label: t('user.login.password'),
        type: 'password',
        name: 'password',
        required: true,
        inputProps: (_b = {}, _b['data-cy'] = 'password', _b)
      }],
      buttonProps: (_c = {}, _c['data-cy'] = 'login-button', _c),
      buttonWrapperProps: {
        justifyContent: 'flex-start'
      },
      initialValues: INITIAL_FORM_VALUES$1,
      submitHandler: formSubmitHandler,
      validationMode: 'onTouched',
      inputsVariant: 'filled',
      validationSchema: Yup__namespace.object().shape({})
    };
  };

  var INITIAL_FORM_VALUES = {
    title: '',
    firstName: '',
    lastName: '',
    telephone: '',
    email: '',
    password: ''
  };
  var TITLES = ['Dr', 'Mr', 'Mrs', 'Ms', 'Other'];
  var useUserSignInFormConfig = function useUserSignInFormConfig(formSubmitHandler) {
    var _a, _b, _c, _d, _e, _f, _g, _h;

    var t = reactI18next.useTranslation().t;
    var TITLE_OPTIONS = TITLES.map(function (title) {
      return {
        label: t("general.titles.".concat(title.toLowerCase())),
        value: title
      };
    });
    return {
      buttonText: t('general.buttons.register'),
      validationMode: 'onSubmit',
      fields: [{
        label: t('user.register.title'),
        name: 'title',
        select: true,
        options: TITLE_OPTIONS,
        required: true,
        inputProps: (_a = {}, _a['data-cy'] = 'register-title-select', _a),
        additionalInputProps: {
          valueToOpen: 'Other',
          name: 'titleInput',
          label: t('user.register.title'),
          required: true,
          inputProps: (_b = {}, _b['data-cy'] = 'register-other-title-input', _b)
        }
      }, {
        label: t('user.register.firstName'),
        name: 'firstName',
        required: true,
        inputProps: (_c = {}, _c['data-cy'] = 'firstName', _c)
      }, {
        label: t('user.register.lastName'),
        name: 'lastName',
        required: true,
        inputProps: (_d = {}, _d['data-cy'] = 'lastName', _d)
      }, {
        label: t('user.register.email'),
        name: 'email',
        required: true,
        inputProps: (_e = {}, _e['data-cy'] = 'email', _e)
      }, {
        label: t('user.register.telephone'),
        name: 'telephone',
        required: true,
        inputProps: (_f = {}, _f['data-cy'] = 'telephone', _f)
      }, {
        type: 'password',
        label: t('user.register.password'),
        name: 'password',
        required: true,
        inputProps: (_g = {}, _g['data-cy'] = 'password', _g)
      }],
      twoColumns: true,
      buttonWrapperProps: {
        justifyContent: 'flex-start'
      },
      buttonProps: (_h = {}, _h['data-cy'] = 'register-button', _h),
      initialValues: INITIAL_FORM_VALUES,
      submitHandler: formSubmitHandler,
      inputsVariant: 'filled',
      validationSchema: Yup__namespace.object().shape({
        title: Yup__namespace.string().label(t('user.register.title')).required(),
        firstName: Yup__namespace.string().label(t('user.register.firstName')).required(),
        lastName: Yup__namespace.string().label(t('user.register.lastName')).required(),
        email: Yup__namespace.string().email().label(t('user.register.email')).required(),
        telephone: Yup__namespace.string().required().min(10).label(t('user.register.telephone')),
        password: Yup__namespace.string().required().matches(/((?=.*[0-9])(?=.*[a-z]).{6,})/, t('user.register.passwordValidation')).label(t('user.register.password'))
      })
    };
  };

  var useRequestResetPasswordFormLogic = function useRequestResetPasswordFormLogic(isMutating) {
    var t = reactI18next.useTranslation().t;
    var navigate = reactRouter.useNavigate();
    return {
      formTitle: t('user.requestResetPassword.formTitle'),
      formTitleVariant: 'h6',
      loading: isMutating,
      initialValues: {
        email: ''
      },
      validationSchema: Yup__namespace.object().shape({
        email: Yup__namespace.string().email().label(t('user.requestResetPassword.email')).required()
      }),
      fields: [{
        name: 'email',
        label: t('user.requestResetPassword.email'),
        required: true
      }],
      secondaryButtons: [{
        label: t('general.buttons.back'),
        onClick: function () {
          return navigate('/login');
        },
        variant: 'outlined'
      }],
      inputsVariant: 'filled',
      validationMode: 'onSubmit',
      buttonWrapperProps: {
        display: 'flex',
        justifyContent: 'space-between'
      },
      buttonText: t('general.buttons.submit')
    };
  };

  var useResetPasswordFormLogic = function useResetPasswordFormLogic(_a) {
    var passwordVisible = _a.passwordVisible,
        setPasswordVisible = _a.setPasswordVisible,
        passwordConfirmVisible = _a.passwordConfirmVisible,
        setPasswordConfirmVisible = _a.setPasswordConfirmVisible,
        isMutating = _a.isMutating;
    var t = reactI18next.useTranslation().t;
    return {
      formTitle: t('user.resetPassword.formTitle'),
      formTitleVariant: 'h6',
      initialValues: {
        password: '',
        passwordConfirm: ''
      },
      loading: isMutating,
      validationMode: 'onBlur',
      validationSchema: Yup__namespace.object().shape({
        password: Yup__namespace.string().matches(/((?=.*[0-9])(?=.*[a-z]).{6,})/, t('user.register.passwordValidation')).label(t('user.resetPassword.newPassword')).required(),
        passwordConfirm: Yup__namespace.string().required().oneOf([Yup__namespace.ref('password'), null], t('general.validations.passwordMatch')).label(t('user.resetPassword.passwordConfirm'))
      }),
      fields: [{
        label: t('user.resetPassword.newPassword'),
        name: 'password',
        required: true,
        type: passwordVisible ? 'text' : 'password',
        endAdornment: {
          element: /*#__PURE__*/React__default["default"].createElement(originUiCore.VisibilityButton, {
            visible: passwordVisible,
            setVisible: setPasswordVisible
          })
        }
      }, {
        label: t('user.resetPassword.passwordConfirm'),
        name: 'passwordConfirm',
        required: true,
        type: passwordConfirmVisible ? 'text' : 'password',
        endAdornment: {
          element: /*#__PURE__*/React__default["default"].createElement(originUiCore.VisibilityButton, {
            visible: passwordConfirmVisible,
            setVisible: setPasswordConfirmVisible
          })
        }
      }],
      inputsVariant: 'filled',
      buttonText: t('general.buttons.submit')
    };
  };

  var prepareUsersData = function prepareUsersData(user, actions) {
    var _a;

    return {
      id: user.id,
      name: "".concat(user.firstName, " ").concat(user.lastName),
      organization: (_a = user.organization) === null || _a === void 0 ? void 0 : _a.name,
      email: user.email,
      status: user.status,
      kycStatus: user.kycStatus,
      actions: actions
    };
  };

  var useAdminUsersTableLogic = function useAdminUsersTableLogic(users, actions, loading) {
    var _a;

    var t = reactI18next.useTranslation().t;
    return {
      header: {
        name: t('admin.users.name'),
        organization: t('admin.users.organization'),
        email: t('admin.users.email'),
        status: t('admin.users.status'),
        kycStatus: t('admin.users.kycStatus'),
        actions: ''
      },
      loading: loading,
      pageSize: 25,
      data: (_a = users === null || users === void 0 ? void 0 : users.map(function (user) {
        return prepareUsersData(user, actions);
      })) !== null && _a !== void 0 ? _a : []
    };
  };

  var STATUS_OPTIONS = Object.keys(originBackendReactQueryClient.UserStatus).map(function (key) {
    return {
      value: key,
      label: key
    };
  });
  var KYC_STATUS_OPTIONS = Object.keys(originBackendReactQueryClient.KYCStatus).map(function (key) {
    return {
      value: key,
      label: key
    };
  });

  var useAdminUpdateUserFormLogic = function useAdminUpdateUserFormLogic(user) {
    var t = reactI18next.useTranslation().t;
    var initialFormData = {
      title: user === null || user === void 0 ? void 0 : user.title,
      firstName: user === null || user === void 0 ? void 0 : user.firstName,
      lastName: user === null || user === void 0 ? void 0 : user.lastName,
      email: user === null || user === void 0 ? void 0 : user.email,
      telephone: user === null || user === void 0 ? void 0 : user.telephone,
      status: user === null || user === void 0 ? void 0 : user.status,
      kycStatus: user === null || user === void 0 ? void 0 : user.kycStatus
    };
    return {
      buttonText: t('general.buttons.update'),
      fields: [{
        label: t('admin.updateUser.title'),
        name: 'title'
      }, {
        label: t('admin.updateUser.firstName'),
        name: 'firstName'
      }, {
        label: t('admin.updateUser.lastName'),
        name: 'lastName'
      }, {
        label: t('admin.updateUser.email'),
        name: 'email'
      }, {
        label: t('admin.updateUser.telephone'),
        name: 'telephone'
      }, {
        label: t('admin.updateUser.status'),
        name: 'status',
        select: true,
        options: STATUS_OPTIONS
      }, {
        label: t('admin.updateUser.kycStatus'),
        name: 'kycStatus',
        select: true,
        options: KYC_STATUS_OPTIONS
      }],
      buttonWrapperProps: {
        justifyContent: 'flex-start'
      },
      initialValues: initialFormData,
      twoColumns: true,
      inputsVariant: 'filled',
      validationSchema: Yup__namespace.object().shape({
        firstName: Yup__namespace.string().label(t('admin.updateUser.firstName')).required(),
        lastName: Yup__namespace.string().label(t('admin.updateUser.lastName')).required(),
        email: Yup__namespace.string().email().label(t('admin.updateUser.email')).required(),
        telephone: Yup__namespace.string().label(t('admin.updateUser.telephone')).required()
      })
    };
  };

  var formatClaims = function formatClaims(_a) {
    var certificates = _a.certificates,
        allDevices = _a.allDevices;
    var formattedClaims = [];
    certificates === null || certificates === void 0 ? void 0 : certificates.forEach(function (certificate) {
      var _a;

      return (_a = certificate.claims) === null || _a === void 0 ? void 0 : _a.forEach(function (claim) {
        var _a;

        formattedClaims.push({
          id: "".concat(certificate.id, ";").concat(claim.claimData.periodStartDate),
          certificateId: certificate.id,
          deviceName: (_a = allDevices.find(function (device) {
            return device.externalRegistryId === certificate.deviceId;
          })) === null || _a === void 0 ? void 0 : _a.name,
          energy: originUiUtils.PowerFormatter.format(parseInt(claim.value), true),
          beneficiary: claim.claimData.beneficiary,
          fromDate: originUiUtils.formatDate(claim.claimData.periodStartDate),
          toDate: originUiUtils.formatDate(claim.claimData.periodEndDate)
        });
      });
    });
    return formattedClaims;
  };

  var useClaimsTableLogic = function useClaimsTableLogic(_a) {
    var isLoading = _a.isLoading,
        certificates = _a.certificates,
        allDevices = _a.allDevices;
    var t = reactI18next.useTranslation().t;
    return {
      header: {
        certificateId: t('admin.claims.certificateId'),
        deviceName: t('admin.claims.deviceName'),
        energy: t('admin.claims.energy'),
        beneficiary: t('admin.claims.beneficiary'),
        fromDate: t('admin.claims.fromDate'),
        toDate: t('admin.claims.toDate')
      },
      pageSize: 10,
      loading: isLoading,
      data: formatClaims({
        certificates: certificates,
        allDevices: allDevices
      })
    };
  };

  var formatTrades = function formatTrades(_a) {
    var trades = _a.trades;
    return (trades === null || trades === void 0 ? void 0 : trades.map(function (trade) {
      var price = trade.price / 100;
      var totalPrice = parseFloat(originUiUtils.EnergyFormatter.format(trade.volume)) * price;
      return {
        id: trade.id,
        dateAndTime: originUiUtils.formatDate(trade.created, true),
        buyerId: trade.bidUserId,
        sellerId: trade.askUserId,
        volume: originUiUtils.EnergyFormatter.format(trade.volume),
        certificateId: trade.tokenId,
        price: price,
        total: "$".concat(totalPrice.toFixed(2))
      };
    })) || [];
  };

  var useTradesTableLogic = function useTradesTableLogic(_a) {
    var trades = _a.trades,
        loading = _a.loading;
    var t = reactI18next.useTranslation().t;
    return {
      header: {
        dateAndTime: t('admin.trades.dateAndTime'),
        buyerId: t('admin.trades.buyerId'),
        sellerId: t('admin.trades.sellerId'),
        certificateId: t('admin.trades.certificateId'),
        volume: "".concat(t('admin.trades.volume'), " (").concat(originUiUtils.EnergyFormatter.displayUnit, ")"),
        price: t('admin.trades.price'),
        total: t('admin.trades.total')
      },
      pageSize: 10,
      loading: loading,
      data: formatTrades({
        trades: trades
      })
    };
  };

  var formatOrganizations = function formatOrganizations(_a) {
    var allOrganizations = _a.allOrganizations,
        actions = _a.actions;
    return allOrganizations === null || allOrganizations === void 0 ? void 0 : allOrganizations.map(function (org) {
      var _a;

      return {
        id: org.id,
        name: org.name,
        country: (_a = utilsGeneral.Countries.find(function (country) {
          return country.code === org.country;
        })) === null || _a === void 0 ? void 0 : _a.name,
        tradeRegistryNumber: org.tradeRegistryCompanyNumber,
        status: org.status,
        actions: org.status === originBackendCore.OrganizationStatus.Submitted ? actions : undefined
      };
    });
  };

  var useAllOrganizationsTableLogic = function useAllOrganizationsTableLogic(_a) {
    var _b;

    var allOrganizations = _a.allOrganizations,
        actions = _a.actions,
        isLoading = _a.isLoading;
    var t = reactI18next.useTranslation().t;
    var navigate = reactRouter.useNavigate();
    return {
      header: {
        name: t('organization.all.name'),
        country: t('organization.all.country'),
        tradeRegistryNumber: t('organization.all.tradeRegistryNumber'),
        status: t('organization.all.status'),
        actions: ''
      },
      onRowClick: function (id) {
        return navigate("/admin/organization/".concat(id));
      },
      pageSize: 20,
      loading: isLoading,
      data: (_b = formatOrganizations({
        allOrganizations: allOrganizations,
        actions: actions
      })) !== null && _b !== void 0 ? _b : []
    };
  };

  var useAdminOrganizationViewLogic = function useAdminOrganizationViewLogic(organization) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;

    var t = reactI18next.useTranslation().t;
    return {
      orgFormData: {
        heading: t('organization.view.regular.title'),
        data: [{
          label: t('organization.view.regular.name'),
          value: (_a = organization === null || organization === void 0 ? void 0 : organization.name) !== null && _a !== void 0 ? _a : ''
        }, {
          label: t('organization.view.regular.address'),
          value: (_b = organization === null || organization === void 0 ? void 0 : organization.address) !== null && _b !== void 0 ? _b : ''
        }, {
          label: t('organization.view.regular.businessType'),
          value: formatOrganizationBusinessType((_c = organization === null || organization === void 0 ? void 0 : organization.businessType) !== null && _c !== void 0 ? _c : '')
        }, {
          label: t('organization.view.regular.tradeRegistry'),
          value: (_d = organization === null || organization === void 0 ? void 0 : organization.tradeRegistryCompanyNumber) !== null && _d !== void 0 ? _d : ''
        }, {
          label: t('organization.view.regular.vat'),
          value: (_e = organization === null || organization === void 0 ? void 0 : organization.tradeRegistryCompanyNumber) !== null && _e !== void 0 ? _e : ''
        }, {
          label: t('organization.view.regular.signatoryName'),
          value: (_f = organization === null || organization === void 0 ? void 0 : organization.signatoryFullName) !== null && _f !== void 0 ? _f : ''
        }, {
          label: t('organization.view.regular.signatoryAddress'),
          value: (_g = organization === null || organization === void 0 ? void 0 : organization.signatoryAddress) !== null && _g !== void 0 ? _g : ''
        }, {
          label: t('organization.view.regular.signatoryEmail'),
          value: (_h = organization === null || organization === void 0 ? void 0 : organization.signatoryEmail) !== null && _h !== void 0 ? _h : ''
        }, {
          label: t('organization.view.regular.signatoryPhone'),
          value: (_j = organization === null || organization === void 0 ? void 0 : organization.signatoryPhoneNumber) !== null && _j !== void 0 ? _j : ''
        }, {
          label: t('organization.view.regular.status'),
          value: (_k = organization === null || organization === void 0 ? void 0 : organization.status) !== null && _k !== void 0 ? _k : ''
        }]
      },
      docsBlockHeading: t('organization.view.regular.documents'),
      companyProofData: {
        documents: (_l = organization === null || organization === void 0 ? void 0 : organization.documentIds) !== null && _l !== void 0 ? _l : [''],
        blockTitle: t('organization.view.regular.companyProof')
      },
      signatoryData: {
        documents: (_m = organization === null || organization === void 0 ? void 0 : organization.signatoryDocumentIds) !== null && _m !== void 0 ? _m : [''],
        blockTitle: t('organization.view.regular.signatoryId')
      }
    };
  };
  var formatOrganizationBusinessType = function formatOrganizationBusinessType(businessType) {
    if (!businessType) return '';
    return utilsGeneral.IRECBusinessLegalStatusLabelsMap[businessType];
  };

  var getAccountMenu = function getAccountMenu(_a) {
    var t = _a.t,
        isOpen = _a.isOpen,
        showSettings = _a.showSettings,
        showUserProfile = _a.showUserProfile,
        selectedMenuItemClass = _a.selectedMenuItemClass,
        menuButtonClass = _a.menuButtonClass;
    return {
      isOpen: isOpen,
      dataCy: 'settingsMenu',
      sectionTitle: showUserProfile ? t('navigation.account.sectionTitle') : t('navigation.account.sectionTitleForUnlogged'),
      rootUrl: '/account',
      show: true,
      menuList: [{
        url: 'settings',
        label: t('navigation.account.settings'),
        show: showSettings,
        dataCy: 'accountSettings'
      }, {
        url: 'profile',
        label: t('navigation.account.userProfile'),
        show: showUserProfile,
        dataCy: 'accountUserProfile'
      }],
      menuButtonClass: menuButtonClass,
      selectedMenuItemClass: selectedMenuItemClass
    };
  };

  var getAdminMenu = function getAdminMenu(_a) {
    var t = _a.t,
        isOpen = _a.isOpen,
        showSection = _a.showSection,
        showUsers = _a.showUsers,
        showAllOrgs = _a.showAllOrgs,
        showClaims = _a.showClaims,
        showTrades = _a.showTrades,
        menuButtonClass = _a.menuButtonClass,
        selectedMenuItemClass = _a.selectedMenuItemClass;
    return {
      isOpen: isOpen,
      dataCy: 'adminMenu',
      sectionTitle: t('navigation.admin.sectionTitle'),
      rootUrl: '/admin',
      show: showSection,
      menuList: [{
        url: 'users',
        label: t('navigation.admin.users'),
        show: showUsers,
        dataCy: 'adminUsers'
      }, {
        url: 'organizations',
        label: t('navigation.admin.organizations'),
        show: showAllOrgs,
        dataCy: 'adminOrganizations'
      }, {
        url: 'claims',
        label: t('navigation.admin.claims'),
        show: showClaims,
        dataCy: 'adminClaims'
      }, {
        url: 'trades',
        label: t('navigation.admin.trades'),
        show: showTrades,
        dataCy: 'adminTrades'
      }],
      menuButtonClass: menuButtonClass,
      selectedMenuItemClass: selectedMenuItemClass
    };
  };

  var useUserRegisteredModalLogic = function useUserRegisteredModalLogic(closeModal) {
    var _a;

    var t = reactI18next.useTranslation().t;
    return {
      title: t('user.modals.userRegistered.title'),
      text: t('user.modals.userRegistered.text'),
      buttons: [(_a = {
        label: t('general.buttons.ok'),
        onClick: closeModal
      }, _a['data-cy'] = 'user-registered-modal-ok', _a)]
    };
  };

  var useLoginRegisterOrgModalLogic = function useLoginRegisterOrgModalLogic(closeModal, navigateToRegister) {
    var t = reactI18next.useTranslation().t;
    return {
      title: t('user.modals.loginRegisterOrg.title'),
      text: t('user.modals.loginRegisterOrg.text'),
      buttons: [{
        label: t('general.buttons.notNow'),
        onClick: closeModal
      }, {
        label: t('user.modals.loginRegisterOrg.registerOrgButton'),
        onClick: navigateToRegister
      }]
    };
  };

  var roleNames = [{
    value: originBackendCore.Role.OrganizationAdmin,
    label: 'user.modals.roleOrgAdmin'
  }, {
    value: originBackendCore.Role.OrganizationDeviceManager,
    label: 'user.modals.roleOrgDeviceManager'
  }, {
    value: originBackendCore.Role.OrganizationUser,
    label: 'user.modals.roleOrgMember'
  }];
  var usePendingInvitationModalLogic = function usePendingInvitationModalLogic(_a) {
    var _b;

    var invitation = _a.invitation,
        acceptHandler = _a.acceptHandler,
        declineHandler = _a.declineHandler,
        laterHandler = _a.laterHandler;
    var t = reactI18next.useTranslation().t;
    return {
      title: t('user.modals.pendingInvitation.title'),
      text: t('user.modals.pendingInvitation.text', {
        admin: invitation === null || invitation === void 0 ? void 0 : invitation.sender,
        role: t((_b = roleNames.find(function (role) {
          return role.value === (invitation === null || invitation === void 0 ? void 0 : invitation.role);
        })) === null || _b === void 0 ? void 0 : _b.label),
        orgName: invitation === null || invitation === void 0 ? void 0 : invitation.organization.name
      }),
      buttons: [{
        label: t('general.buttons.later'),
        onClick: function () {
          return laterHandler(invitation.id);
        }
      }, {
        label: t('general.buttons.decline'),
        onClick: function () {
          return declineHandler(invitation.id);
        }
      }, {
        label: t('general.buttons.accept'),
        onClick: function () {
          return acceptHandler(invitation.id);
        }
      }]
    };
  };

  var useCreateExchangeAddressModalLogic = function useCreateExchangeAddressModalLogic(closeModal, navigateToCreate) {
    var t = reactI18next.useTranslation().t;
    return {
      title: t('user.modals.createExchangeAddress.title'),
      text: t('user.modals.createExchangeAddress.text'),
      buttons: [{
        label: t('general.buttons.notNow'),
        onClick: closeModal
      }, {
        label: t('user.modals.createExchangeAddress.create'),
        onClick: navigateToCreate
      }]
    };
  };

  var getRoleChangedLogic = function getRoleChangedLogic(_a) {
    var t = _a.t,
        closeModal = _a.closeModal,
        role = _a.role,
        orgName = _a.orgName,
        isIRecEnabled = _a.isIRecEnabled;

    var memberActions = function memberActions(isMainRole) {
      return {
        title: isMainRole ? t('organization.modals.roleChanged.asMemberYouCan') : t('organization.modals.roleChanged.asAMemberYouCanAlso'),
        actions: [t('organization.modals.roleChanged.canPlaceOrder'), t('organization.modals.roleChanged.canBuyCertificates', {
          certificateType: isIRecEnabled ? 'I-RECs' : 'certificates'
        }), t('organization.modals.roleChanged.canCreateAndBuyCertificateBundles', {
          certificateType: isIRecEnabled ? 'I-REC' : 'certificate'
        }), t('organization.modals.roleChanged.canRedeemCertificates', {
          certificateType: isIRecEnabled ? 'I-RECs' : 'certificates'
        }), t('organization.modals.roleChanged.canWithdrawCertificates', {
          certificateType: isIRecEnabled ? 'I-RECs' : 'certificates'
        })]
      };
    };

    var deviceManagerActions = function deviceManagerActions(isMainRole) {
      return {
        title: isMainRole ? t('organization.modals.roleChanged.asDeviceManagerYouCan') : t('organization.modals.roleChanged.asDeviceManagerYouCanAlso'),
        actions: [t('organization.modals.roleChanged.canRegisterDevices'), t('organization.modals.roleChanged.canRequestIssuenceOfCertificates', {
          certificateType: isIRecEnabled ? 'I-RECs' : 'certificates'
        }), t('organization.modals.roleChanged.canConfigureAutomatedOrderCreation')]
      };
    };

    var orgAdminActions = {
      title: t('organization.modals.roleChanged.asOrgAdminYouCan'),
      actions: [t('organization.modals.roleChanged.canAddOrRemoveOrgMembers'), t('organization.modals.roleChanged.canEditUserRoles'), isIRecEnabled && t('organization.modals.roleChanged.connectOrgToIRec')]
    };
    var roleDescriptions = role === originBackendCore.Role.OrganizationUser ? [memberActions(true)] : role === originBackendCore.Role.OrganizationDeviceManager ? [deviceManagerActions(true), memberActions(false)] : role === originBackendCore.Role.OrganizationAdmin ? [orgAdminActions, deviceManagerActions(false), memberActions(false)] : [];
    return {
      title: t('organization.modals.roleChanged.title', {
        organizationName: orgName
      }),
      subtitle: t('organization.modals.roleChanged.text', {
        organizationName: orgName
      }),
      roleDescriptions: roleDescriptions,
      buttons: [{
        label: 'Ok',
        onClick: closeModal
      }]
    };
  };

  var getTopbarButtonList = function getTopbarButtonList(isAuthenticated, onLogout, t, navigate) {
    return [{
      label: t('navigation.topbar.register'),
      show: !isAuthenticated,
      onClick: function () {
        navigate('/auth/register');
      },
      Icon: iconsMaterial.HowToReg,
      dataCy: 'navigation-register-button'
    }, {
      label: t('navigation.topbar.login'),
      show: !isAuthenticated,
      onClick: function () {
        navigate('/login');
      },
      Icon: iconsMaterial.AccountCircle,
      dataCy: 'navigation-login-button'
    }, {
      label: t('navigation.topbar.logout'),
      show: isAuthenticated,
      onClick: onLogout,
      Icon: iconsMaterial.ExitToApp,
      dataCy: 'navigation-logout-button'
    }];
  };

  var useUserAndOrgData = function useUserAndOrgData(user) {
    var _a;

    var t = reactI18next.useTranslation().t;
    return {
      userData: {
        username: "".concat(user === null || user === void 0 ? void 0 : user.firstName, " ").concat(user === null || user === void 0 ? void 0 : user.lastName),
        userPending: (user === null || user === void 0 ? void 0 : user.kycStatus) === originBackendCore.KYCStatus.Pending || (user === null || user === void 0 ? void 0 : user.status) === originBackendCore.UserStatus.Pending,
        userTooltip: t('navigation.layout.userPendingTooltip')
      },
      orgData: {
        orgName: (_a = user === null || user === void 0 ? void 0 : user.organization) === null || _a === void 0 ? void 0 : _a.name,
        orgPending: (user === null || user === void 0 ? void 0 : user.organization) && user.organization.status !== originBackendReactQueryClient.OrganizationStatus.Active,
        orgTooltip: t('navigation.layout.orgPendingTooltip')
      }
    };
  };

  exports.INITIAL_FORM_VALUES = INITIAL_FORM_VALUES$1;
  exports.formatOrganizationBusinessType = formatOrganizationBusinessType;
  exports.getAccountMenu = getAccountMenu;
  exports.getAdminMenu = getAdminMenu;
  exports.getRoleChangedLogic = getRoleChangedLogic;
  exports.getTopbarButtonList = getTopbarButtonList;
  exports.roleNames = roleNames;
  exports.useAdminOrganizationViewLogic = useAdminOrganizationViewLogic;
  exports.useAdminUpdateUserFormLogic = useAdminUpdateUserFormLogic;
  exports.useAdminUsersTableLogic = useAdminUsersTableLogic;
  exports.useAllOrganizationsTableLogic = useAllOrganizationsTableLogic;
  exports.useClaimsTableLogic = useClaimsTableLogic;
  exports.useConnectMetamaskPlaceholderLogic = useConnectMetamaskPlaceholderLogic;
  exports.useCreateExchangeAddressModalLogic = useCreateExchangeAddressModalLogic;
  exports.useExchangeDepositAddressLogic = useExchangeDepositAddressLogic;
  exports.useLoginRegisterOrgModalLogic = useLoginRegisterOrgModalLogic;
  exports.useOrganizationBlockchainAddressLogic = useOrganizationBlockchainAddressLogic;
  exports.usePendingInvitationModalLogic = usePendingInvitationModalLogic;
  exports.useRequestResetPasswordFormLogic = useRequestResetPasswordFormLogic;
  exports.useResetPasswordFormLogic = useResetPasswordFormLogic;
  exports.useSettingsPageLogic = useSettingsPageLogic;
  exports.useTradesTableLogic = useTradesTableLogic;
  exports.useUpdateUserAccountDataFormConfig = useUpdateUserAccountDataFormConfig;
  exports.useUpdateUserAccountEmailFormConfig = useUpdateUserAccountEmailFormConfig;
  exports.useUpdateUserAccountPasswordFormConfig = useUpdateUserAccountPasswordFormConfig;
  exports.useUserAndOrgData = useUserAndOrgData;
  exports.useUserLogInFormConfig = useUserLogInFormConfig;
  exports.useUserRegisteredModalLogic = useUserRegisteredModalLogic;
  exports.useUserSignInFormConfig = useUserSignInFormConfig;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
